"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RcjsonOutliner = void 0;
const vscode = require("vscode");
class RcjsonOutliner {
    constructor() {
        this.componentOrder = [
            "id", "comment", "label", "labels", "descriptions", "parameterGroups", "parameters", "subComponents",
            "onUpdate", "previewGeometry", "geometry", "geometryHD", "debugGeometry", "siblings", "parentDockings", "childDockings", "addOnSpots",
            "possibleChildren", "packageSizes", "packaging", "dimensionings", "valid", "articleNr", "pricing", "plugin-data"
        ];
    }
    provideDocumentSymbols(document) {
        return __awaiter(this, void 0, void 0, function* () {
            return new Promise((resolve) => {
                var symbols = [];
                let foundComponentAttributes = {};
                for (var i = 0; i < document.lineCount; i++) {
                    var line = document.lineAt(i);
                    var lineText = line.text;
                    if (lineText.startsWith("    \"")) {
                        var split = lineText.split('\"');
                        if (split.length > 2) {
                            var foundAttribute = split[1];
                            foundComponentAttributes[foundAttribute] =
                                {
                                    "lineAt": i,
                                    "lineRange": line.range,
                                    "lineText": lineText
                                };
                        }
                    }
                }
                for (let i = 0; i < this.componentOrder.length; i++) {
                    let sortedAttribute = this.componentOrder[i];
                    if (foundComponentAttributes[sortedAttribute]) {
                        let symbol = new vscode.DocumentSymbol(i + ":\t" + sortedAttribute, '', vscode.SymbolKind.Function, foundComponentAttributes[sortedAttribute].lineRange, foundComponentAttributes[sortedAttribute].lineRange);
                        symbols.push(symbol);
                    }
                }
                resolve(symbols);
            });
        });
    }
}
exports.RcjsonOutliner = RcjsonOutliner;
//# sourceMappingURL=outliner.js.map